<template>
  <main>
    <section class="section">
      <h1 class="stats-section-title">
        {{ $t('pages.stats.stats_title') }}
      </h1>
      <ol v-if="stats" class="wrapper-stats">
        <Metrics
          v-for="metric in stats.slice(0, 3)"
          :key="metric.number"
          :number="metric.number"
          :text="metric.text"
          :description="metric.description"
        />
      </ol>
      <div v-if="dataStatsByContributors.length" class="wrapper-leaderboard">
        <div class="wrapper-charts-subtitle">
          <button
            id="leaderboard"
            class="subtitle-button"
            @click="copyToClipboard('#leaderboard')"
          >
            <img
              src="@/assets/images/lien.svg"
              loading="lazy"
              class="subtitle-button-img"
            />
          </button>
          <h2 class="charts-subtitle">
            {{ $t('pages.leaderboard.leaderboard_title') }}
          </h2>
        </div>
        <div class="entry-leaderboard">
          <Leaderboard :stats-by-contributors="dataStatsByContributors" />
          <div class="entry-leaderboard-button">
            <Link
              :text="$t('pages.stats.info_leaderboard_link')"
              url="/leaderboard"
              look="button button--blue"
            />
          </div>
        </div>
      </div>
      <div class="wrapper-charts">
        <div class="wrapper-charts-subtitle">
          <button
            id="photos"
            class="subtitle-button"
            @click="copyToClipboard('#photos')"
          >
            <img
              src="@/assets/images/lien.svg"
              loading="lazy"
              class="subtitle-button-img"
            />
          </button>
          <h2 class="charts-subtitle">
            {{ $t('pages.stats.chart_line_picture_title') }}
          </h2>
        </div>
        <div class="charts">
          <LineChart
            :labels="dataLabels"
            :datasets="[{ data: dataPictures }]"
            :is-millions="true"
          />
          <div class="wrapper-stat-desc">
            <StatsBlockDescription
              v-if="stats"
              :title="$t('pages.stats.chart_pictures_title')"
              :sub-title="$t('pages.stats.chart_desc')"
              :text-desc="
                $t('pages.stats.chart_line_picture_desc', {
                  number: stats[0].number
                })
              "
            />
          </div>
        </div>
      </div>
      <div class="wrapper-charts">
        <div class="wrapper-charts-subtitle">
          <button
            id="contributeurs"
            class="subtitle-button"
            @click="copyToClipboard('#contributeurs')"
          >
            <img
              src="@/assets/images/lien.svg"
              loading="lazy"
              class="subtitle-button-img"
            />
          </button>
          <h2 class="charts-subtitle">
            {{ $t('pages.stats.chart_bar_contrib_title') }}
          </h2>
        </div>
        <div class="charts">
          <div class="wrapper-bar-charts">
            <BarChart v-bind="barChartProps" />
          </div>
          <div class="wrapper-stat-desc">
            <StatsBlockDescription
              v-if="stats"
              :title="$t('pages.stats.chart_contrib_title')"
              :text-desc="
                $t('pages.stats.chart_bar_contrib_desc', {
                  number: stats[2].number
                })
              "
            />
          </div>
        </div>
      </div>
      <div class="wrapper-charts-doughnut">
        <div class="wrapper-doughnut-charts">
          <h3 class="doughnut-subtitle">
            {{ $t('pages.stats.doughnut_pictures_title') }}
          </h3>
          <DoughnutChart
            :labels="instancesList.map((e) => e.name)"
            :datasets="[
              {
                data: dataPicturesInstancesPercentage,
                backgroundColor: instancesList.map((e) => e.color),
                datalabels: {
                  formatter: (value: number, context: any) =>
                    formatterData(value, context, dataPicturesInstances, 'millions'),
                  ...doughnutProperties
                }
              }
            ]"
          />
        </div>
        <div class="wrapper-doughnut-charts">
          <h3 class="doughnut-subtitle">
            {{ $t('pages.stats.doughnut_km_title') }}
          </h3>
          <DoughnutChart
            :labels="instancesList.map((e) => e.name)"
            :datasets="[
              {
                data: dataCovKmInstancesPercentage,
                backgroundColor: instancesList.map((e) => e.color),
                datalabels: {
                  formatter: (value: number, context: any) =>
                    formatterData(value, context, dataCovKmInstances),
                  ...doughnutProperties
                }
              }
            ]"
          />
        </div>
        <div class="wrapper-doughnut-charts">
          <h3 class="doughnut-subtitle">
            {{ $t('pages.stats.doughnut_contrib_title') }}
          </h3>
          <DoughnutChart
            :labels="instancesList.map((e) => e.name)"
            :datasets="[
              {
                data: dataContribInstancesPercentage,
                backgroundColor: instancesList.map((e) => e.color),
                datalabels: {
                  formatter: (value: number, context: any) =>
                    formatterData(value, context, dataContribInstances),
                  ...doughnutProperties
                }
              }
            ]"
          />
        </div>
      </div>
      <p class="stats-info">
        {{ $t('pages.stats.stats_info') }}
      </p>
    </section>
  </main>
</template>

<script lang="ts" setup>
import { computed, onMounted, ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { formatNumber, formatInstanceList } from '@/utils'
import { BarChart, useBarChart } from 'vue-chart-3'
import { Chart, registerables } from 'chart.js'
import Link from '@/components/Link.vue'
import Metrics from '@/components/Metrics.vue'
import LineChart from '@/components/LineChart.vue'
import Leaderboard from '@/components/Leaderboard.vue'
import DoughnutChart from '@/components/DoughnutChart.vue'
import StatsBlockDescription from '@/components/StatsBlockDescription.vue'
import ChartDataLabels from 'chartjs-plugin-datalabels'
import type { ChartData } from '@/interfaces/index'
import type { StatsByContributor } from '@/interfaces/leaderboard'
Chart.register(...registerables, ChartDataLabels)

let stats = ref<MetricsData[]>()
const dataCovKm = ref<number[]>([])
const dataPictures = ref<number[]>([])
const dataCovKmInstances = ref<number[]>([])
const dataCovKmInstancesPercentage = ref<number[]>([])
const dataPicturesInstances = ref<number[]>([])
const dataPicturesInstancesPercentage = ref<number[]>([])
const dataContribInstances = ref<number[]>([])
const dataContribInstancesPercentage = ref<number[]>([])
const dataActiveContrib = ref<number[]>([])
const dataStatsByContributors = ref<StatsByContributor[]>([])
const dataLabels = ref<string[]>([])
const instancesList = ref<{ name: string; color: string; logo: string }[]>([])
const averagePictures = ref<string>('')
const averageKm = ref<string>('')
interface MetricsData {
  number: string
  text: string
  description: string
}
const { t } = useI18n()

const formatterData = function (
  value: number,
  context: { dataIndex: number },
  data: any,
  unit?: string
): string {
  if (unit?.length && data[context.dataIndex].toString().length > 6) {
    return `${formatNumber(data[context.dataIndex])} ${unit}`
  }
  return formatNumber(data[context.dataIndex])
}

const doughnutProperties = {
  color: '#0A1F69',
  align: 'center',
  backgroundColor: 'white',
  borderStyle: 'solid',
  borderWidth: '1',
  borderColor: '#0A1F69',
  borderRadius: '5',
  font: {
    weight: 'bold'
  }
}
const activeContribData = computed<ChartData>(() => ({
  labels: dataLabels.value,
  datasets: [
    {
      data: dataActiveContrib.value,
      backgroundColor: ['#0A1F69'],
      borderRadius: 5,
      datalabels: {
        color: 'white'
      }
    }
  ]
}))

const { barChartProps } = useBarChart({
  chartData: activeContribData,
  options: {
    plugins: {
      legend: {
        display: false
      }
    }
  }
})

onMounted(async () => {
  const api = import.meta.env.VITE_API_URL
  let [dataStats, dataStatsByContributor] = await Promise.all([
    fetch(`${api}stats/`),
    fetch(`${api}stats/by_contributor/`)
  ])
  const jsonDataStats = await dataStats.json()
  const jsonDataStatsByContributor = await dataStatsByContributor.json()
  dataStatsByContributors.value =
    jsonDataStatsByContributor.stats_by_contributor.sort(
      (a: StatsByContributor, b: StatsByContributor) => b.nb_items - a.nb_items
    )
  let listInstance: string[] = []
  Object.keys(jsonDataStats.stats_by_instance).forEach(function (key) {
    listInstance = [...listInstance, key]
  })
  let totalCollectionsLengthKm = 0
  let totalNbPictures = 0
  let totalNbContrib = 0
  listInstance.map((e) => {
    totalCollectionsLengthKm =
      totalCollectionsLengthKm +
      jsonDataStats.stats_by_instance[e].collections_length_km
    totalNbPictures =
      totalNbPictures + jsonDataStats.stats_by_instance[e].nb_pictures
    totalNbContrib =
      totalNbContrib + jsonDataStats.stats_by_instance[e].nb_contributors
  })
  listInstance.map((e) => {
    dataCovKmInstancesPercentage.value = [
      ...dataCovKmInstancesPercentage.value,
      calcPercentageTwoNumber(
        totalCollectionsLengthKm,
        jsonDataStats.stats_by_instance[e].collections_length_km
      )
    ]
    dataPicturesInstancesPercentage.value = [
      ...dataPicturesInstancesPercentage.value,
      calcPercentageTwoNumber(
        totalNbPictures,
        jsonDataStats.stats_by_instance[e].nb_pictures
      )
    ]
    dataContribInstancesPercentage.value = [
      ...dataContribInstancesPercentage.value,
      calcPercentageTwoNumber(
        totalNbContrib,
        jsonDataStats.stats_by_instance[e].nb_contributors
      )
    ]
    dataCovKmInstances.value = [
      ...dataCovKmInstances.value,
      jsonDataStats.stats_by_instance[e].collections_length_km
    ]
    dataPicturesInstances.value = [
      ...dataPicturesInstances.value,
      jsonDataStats.stats_by_instance[e].nb_pictures
    ]
    dataContribInstances.value = [
      ...dataContribInstances.value,
      jsonDataStats.stats_by_instance[e].nb_contributors
    ]
  })
  stats.value = [
    {
      number: formatNumber(jsonDataStats.generic_stats.nb_pictures),
      text: t('pages.home.metrics_pictures.text'),
      description: t('pages.home.metrics_pictures.description')
    },
    {
      number: formatNumber(jsonDataStats.generic_stats.collections_length_km),
      text: t('pages.home.metrics_km.text'),
      description: t('pages.home.metrics_km.description')
    },
    {
      number: jsonDataStats.generic_stats.nb_contributors,
      text: t('pages.home.metrics_contributors.text'),
      description: t('pages.home.metrics_contributors.description')
    },
    {
      number: formatNumber(
        jsonDataStats.generic_stats.approximated_coverage_km
      ),
      text: t('pages.home.metrics_km.text'),
      description: t('pages.home.metrics_km.description')
    }
  ]
  const resultCalc = calculateMonthlySum(jsonDataStats.stats_by_upload_month)
  instancesList.value = formatInstanceList(listInstance)
  dataLabels.value = resultCalc.months
  dataPictures.value = resultCalc.nb_pictures
  dataActiveContrib.value = resultCalc.nb_active_contributors
  dataCovKm.value = resultCalc.collections_length_km
  averagePictures.value = `${dataLabels.value.length + 1} ${t(
    'pages.stats.stats_month'
  )}`
  averageKm.value = `${dataLabels.value.length + 1} ${t(
    'pages.stats.stats_month'
  )}`
})
function calcPercentageTwoNumber(total: number, numberToCalc: number): number {
  return Math.round((numberToCalc / total) * 100)
}
async function copyToClipboard(value: string): Promise<void> {
  const fullUrl = `${window.location.origin}${window.location.pathname}${value}`
  await navigator.clipboard.writeText(fullUrl).then(
    () => true,
    () => false
  )
}
function calculateMonthlySum(data: Record<string, any>): {
  months: string[]
  nb_pictures: number[]
  nb_active_contributors: number[]
  collections_length_km: number[]
  approximated_coverage_km: number[]
  nb_contributors: number[]
  pictures_original_size: number[]
} {
  const result: Record<string, number[]> = {}
  const months: string[] = []

  for (const month in data) {
    if (Object.prototype.hasOwnProperty.call(data, month)) {
      months.push(month)
      const monthData = data[month]

      for (const key in monthData) {
        if (Object.prototype.hasOwnProperty.call(monthData, key)) {
          const entry = monthData[key]

          for (const field in entry) {
            if (Object.prototype.hasOwnProperty.call(entry, field)) {
              if (!result[field]) {
                result[field] = []
              }
              const monthIndex = months.indexOf(month)

              if (!result[field][monthIndex]) {
                result[field][monthIndex] = 0
              }
              result[field][monthIndex] += entry[field]
            }
          }
        }
      }
    }
  }
  for (const field in result) {
    if (Object.prototype.hasOwnProperty.call(result, field)) {
      const values = []
      for (const value of result[field]) {
        values.push(value)
      }
      result[field] = values
    }
  }
  return {
    months,
    nb_pictures: result.nb_pictures,
    nb_active_contributors: result.nb_active_contributors,
    collections_length_km: result.collections_length_km,
    approximated_coverage_km: result.approximated_coverage_km,
    nb_contributors: result.nb_contributors,
    pictures_original_size: result.pictures_original_size
  }
}
</script>

<style scoped lang="scss">
.section {
  padding: 3rem 15% 6rem;
}
.stats-section-title {
  @include title();
  margin-bottom: 4rem;
}
.wrapper-stats {
  display: flex;
  justify-content: center;
  margin-top: 3rem;
}
.wrapper-leaderboard {
  margin-top: 12rem;
}
.wrapper-charts {
  margin-top: 10rem;
}
.wrapper-charts-subtitle {
  display: flex;
  align-items: center;
  margin-bottom: 2rem;
}
.subtitle-button {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 0;
  background-color: transparent;
  border: none;
  cursor: pointer;
  margin-right: 1rem;
}
.subtitle-button:hover {
  opacity: 0.7;
}
.subtitle-button-img {
  height: 2rem;
}
.doughnut-subtitle {
  margin-bottom: 2rem;
  text-align: center;
}
.charts {
  display: flex;
  width: 100%;
}
.entry-leaderboard {
  margin-top: 2rem;
}
.entry-leaderboard-button {
  margin-top: 3rem;
  display: flex;
  justify-content: center;
}
.wrapper-bar-charts {
  width: 100%;
}
.wrapper-charts:nth-child(odd) .charts {
  flex-direction: row-reverse;
}
.wrapper-charts:nth-child(odd) .wrapper-stat-desc {
  margin-right: 2rem;
  margin-left: 0;
}
.wrapper-stat-desc {
  width: 40%;
  background-color: var(--blue-ligth);
  border-radius: 2rem;
  padding: 2rem;
  margin-left: 2rem;
}
.wrapper-charts-doughnut {
  display: flex;
  margin-top: 10rem;
}
.wrapper-doughnut-charts {
  width: 33%;
}
.stats-desc {
  white-space: pre-wrap;
}
.stats-info {
  margin-top: 10rem;
}
@media (max-width: 1324px) {
  .section {
    padding: 3rem 10%;
  }
}
@media (max-width: 1024px) {
  .wrapper-stats {
    flex-direction: column;
  }
}
@media (max-width: 768px) {
  .section {
    padding: 2rem;
  }
  .wrapper-charts-doughnut {
    flex-direction: column;
  }
  .wrapper-doughnut-charts {
    width: 100%;
    margin-bottom: 2rem;
  }
  .charts,
  .wrapper-charts:nth-child(odd) .charts {
    flex-direction: column;
  }
  .wrapper-stat-desc {
    margin-left: 0;
    margin-right: 0;
    margin-top: 3rem;
    width: 100%;
  }
}
</style>
